package de.ctdo.bunti.dao;

import java.util.List;

import de.ctdo.bunti.model.*;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;


public final class BuntiDevicesDAOImpl extends HibernateDaoSupport implements BuntiDevicesDAO {

	@Override
	public List<BuntiDMXDevice> getAllDMXDevices() {
        return getHibernateTemplate().loadAll(BuntiDMXDevice.class);
	}

    @Override
    public List<BuntiDevice> getAllDevices() {
        return getHibernateTemplate().loadAll(BuntiDevice.class);
    }
	
	@Override
	public BuntiDevice getDeviceById(int deviceId) {
        return getHibernateTemplate().get(BuntiDevice.class,deviceId);
	}

    @Override
    public void addDevice(BuntiDevice device) {
        getHibernateTemplate().save(device);
    }

    @Override
    public void removeDevice(int deviceId) {
        getHibernateTemplate().delete(getDeviceById(deviceId));
    }

}
