package de.ctdo.bunti.web;

import de.ctdo.bunti.dao.RoomsDAO;
import de.ctdo.bunti.model.BuntiDevice;
import de.ctdo.bunti.model.Room;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import java.util.Collection;
import java.util.List;

@Controller
@RequestMapping(value = "/rooms")
public class RoomsController {
    private RoomsDAO roomsDAO;

    @Autowired
    public void setRoomsDAO(RoomsDAO roomsDAO) {
        this.roomsDAO = roomsDAO;
    }

    @RequestMapping(value = "", method = RequestMethod.GET)
    public @ResponseBody Collection<Room> getAll() {
        return roomsDAO.getRooms();
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public @ResponseBody Room getRoomById(@PathVariable("id") int id) {
        return roomsDAO.getRoom(id);
    }

    @RequestMapping(value = "/{id}/devices", method = RequestMethod.GET)
    public @ResponseBody
    List<BuntiDevice> getDevicesFromRoom(@PathVariable("id") int id) {
        Room room = roomsDAO.getRoom(id);

        if(room != null) {
            return room.getDevices();
        }
        
        return null;
    }

}
